﻿// Susan usings.
using Celeste.Mod.UI;
using FMOD.Studio;
using Microsoft.Xna.Framework;
using Monocle;
using Celeste;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Celeste.Mod.SusanHelper
{
    public class SusanModule : EverestModule
    {

        // Only one alive module instance can exist at any given time.
        public static SusanModule Instance;
        public static SpriteBank SpriteBank;

        public SusanModule()
        {
            Instance = this;
        }

        public override Type SessionType => typeof(SusanHelperSession);
        public static SusanHelperSession Session => (SusanHelperSession)Instance._Session;

        public override Type SettingsType => typeof(SusanModuleSettings);
        public static SusanModuleSettings Settings => (SusanModuleSettings)Instance._Settings;

        // Check the next section for more information about mod settings, save data and session.
        // Those are optional: if you don't need one of those, you can remove it from the module.

        public static Player GetPlayer()
        {
            return (Engine.Scene as Level)?.Tracker?.GetEntity<Player>();
        }

        public static bool TryGetPlayer(out Player player)
        {
            player = GetPlayer();
            return player != null;
        }

        // Set up any hooks, event handlers and your mod in general here.
        // Load runs before Celeste itself has initialized properly.
        public override void Load()
        {
        }

        // Optional, initialize anything after Celeste has initialized itself properly.
        public override void Initialize()
        {
        }




        // Optional, do anything requiring either the Celeste or mod content here.
        public override void LoadContent(bool firstLoad)
        {
            base.LoadContent(firstLoad);
            SpriteBank = new SpriteBank(GFX.Game, "Graphics/SusanHelper/Sprites.xml");
        }

        // Unload the entirety of your mod's content. Free up any native resources.
        public override void Unload()
        {
        }

    }
}